####  Admin Tools 0.7 by Leletto
####  a simple tool to help Assetto Corsa server admins
####  based on the great courtesy app by Minolin
####  thanks to Minolin, Iroiroiro, MegadetH, Stereo, Never Eat Yellow Snow and the other guys of the great AC community
####  thanks to Gugo ( ROBYF1 friend ) and Zacks for the suggestions and help

import ac
import acsys
import sys
import os.path
import configparser
import re
import pickle
import time
import json

sys.path.insert(0,'apps/python/admintools/stdlib')
from urllib.request import urlopen

### import path of assetto corsa log. Thanks to Never Eat Yellow Snow ( and Frank Zappa too )
try:
    import winreg
    k = winreg.OpenKey(winreg.HKEY_CURRENT_USER, r"Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders")
    v = winreg.QueryValueEx(k, "Personal")
    launch_dbgLog = os.path.join(v[0], 'Assetto Corsa\logs\launcher_debug.log')
except:
    os.path.join("/tmp", 'Assetto Corsa\logs\launcher_debug.log')

ac.log("Serverinfo:: launcher_debug.log path: " + launch_dbgLog )

### read password archive or create a new one
try:
    with open('apps/python/admintools/config/password.txt', 'rb') as handle:
        passwordarchive = pickle.loads(handle.read())
except:
    passwordarchive={}
    with open('apps/python/admintools/config/password.txt', 'wb') as handle:
        pickle.dump(passwordarchive, handle)

updUsr = False
passwordInput = ""
passwordStore = ""
button_admin = 0
button_nxt_session = 0
button_rst_session = 0
button_lst_users = 0
button_nxt_track = 0
spinner_usr_id = 1
user_to_kick = ""
nextTrackSelected = False
lastMessage = 0
trackMessage = 0

### Default maxConnection in case of missing log file
maxConnection = 16

### Default configuration settings
useAcTrackcycle = True
useUserList = True
useUserId = True
maxWarnLevel = 3
warningMessage = "*Warning #$$w: Please, $$u, behave yourself or you will be kicked!!"
useAutoKick = False
devMode = False
zoomLevel = 1

def acMain(ac_version):
    global appWindow,lstUsr, updUsr, maxConnection, maxWarnLevel, warningMessage, devMode
    global label_test_msg, nextTrackSelected, lastMessage, trackMessage
    global passwordInput, passwordStore, user_to_kick, passwordarchive,serverName, useUserId,serverIp
    global useUserList, useAcTrackcycle, useAutoKick
    global button_admin, button_nxt_session, button_rst_session, button_lst_users
    global button_nxt_track, button_kck_user, button_upd_users, spinner_usr_id
    global button_Zoom, zoomLevel, config

    try:
        ### Get configuration from config.ini
        config = configparser.ConfigParser()
        config.read("apps/python/admintools/config/config.ini")
        
        useAcTrackcycle = config.getboolean("AC_Trackcycle", "use_ac_trackcycle")
        useUserList = config.getboolean ("User_List","use_user_list")
        useUserId = config.getboolean ("User_List","use_user_id")
        maxWarnLevel = config.getint ("Warnings", "maxWarnLevel")
        warningMessage = config.get ("Warnings","warningMessage")
        useAutoKick = config.getboolean ("Warnings","useAutoKick")
        zoomLevel = config.getfloat("Zoom","zoomLevel")
        devMode = config.getboolean("Development","devMode")

    except:
        #### No configuration/corrupted file - Default used and write a new file
        ac.log("Admin tools :: Can't read config - Default used")
        try:
            os.remove("apps/python/admintools/config/config.ini")
        except:
            ac.log("Admin tools :: Can't remove file")
        try:
            config = None
            config = configparser.ConfigParser()
            config.add_section('AC_Trackcycle')
            config.add_section('User_List')
            config.add_section('Warnings')
            config.add_section('Development')
            config.add_section('Zoom')

            config.set('AC_Trackcycle',"use_ac_trackcycle",str(useAcTrackcycle))

            config.set('User_List',"use_user_list",str(useUserList))
            config.set('User_List',"use_user_id",str(useUserId))

            config.set('Warnings',"maxWarnLevel",str(maxWarnLevel))
            config.set('Warnings',"warningMessage",warningMessage)
            config.set('Warnings',"useAutoKick",str(useAutoKick))
            
            config.set('Development',"devMode",str(devMode))

            config.set('Zoom',"zoomLevel",str(zoomLevel))

            configfile = open("apps/python/admintools/config/config.ini","w")
            config.write(configfile)
            configfile.close()
        except:
            ac.log("Admin Tool :: Can't create configparser sections")

    ### Get Server Ip
    try:
        serverIp = parseServerIpFromLogFile(launch_dbgLog)
    except:
        ac.log("Admin tools :: Can't get serverIp")

    if serverIp != "":
        try:
            ### get ServerName and Max clients with Json
            url = "http://" + serverIp + "/INFO"
            response = urlopen(url)

            data = response.read()
            json_data = json.loads(data.decode('utf-8'))
            serverName = json_data["name"]
            maxConnection = int(json_data["maxclients"])
        except:
            ac.log("Admin tools :: Can't contact server")

    ### find password
    try:
        passwordStore = passwordarchive[serverName]
    except:
        passwordStore = ""
 
    ### Create App Windows
    appWindow = ac.newApp("admintools")
    ac.drawBorder(appWindow,0)
    ac.setBackgroundOpacity(appWindow,0)
    ac.setTitle(appWindow,"Admin Tools")
    

    ### Label Password Input
    passwordInput = ac.addTextInput(appWindow,"Password input")
    ac.setText(passwordInput,passwordStore)

    ### Button Admin
    button_admin = ac.addButton(appWindow,"Login")
    ac.setFontColor(button_admin,0,0.8,0,1)
    ac.addOnClickedListener(button_admin,click_button_admin)
        
    ### Button Next Session
    button_nxt_session = ac.addButton(appWindow,"Next Session")
    ac.addOnClickedListener(button_nxt_session,click_button_nxt_session)
    
    ### Button Reset Session
    button_rst_session = ac.addButton(appWindow,"Restart Session")
    ac.addOnClickedListener(button_rst_session,click_button_rst_session)

    ### Button AC_Trackcycle
    if useAcTrackcycle:
        button_nxt_track = ac.addButton(appWindow,"Next Track")
        ac.addOnClickedListener(button_nxt_track,click_button_nxt_track)
    
    if useUserId:
        ### Button List User
        button_lst_users = ac.addButton(appWindow,"List Users")
        ac.addOnClickedListener(button_lst_users,click_button_lst_users)
    
        ### Spinner select user    
        spinner_usr_id = ac.addSpinner(appWindow, "")
        ac.setRange(spinner_usr_id, 0, maxConnection)
        ac.setStep(spinner_usr_id, 1)
        ac.setValue(spinner_usr_id,0)
    
        ### Button Kick User
        button_kck_user = ac.addButton(appWindow,"Kick User Id")
        ac.addOnClickedListener(button_kck_user,click_button_kck_user)

    if useUserList:
        ### Button update users and user list
        button_upd_users = ac.addButton(appWindow,"Update User List")
        ac.addOnClickedListener(button_upd_users,click_button_upd_user)
        lstUsr = []
        for num in range(0,maxConnection):
            lstUsr.append(usrRow(appWindow,num))

    if devMode:
        ### Label for testing purpose
        label_test_msg = ac.addLabel(appWindow,"")
        ac.setPosition(label_test_msg,0,-15)
        ac.setSize(label_test_msg,275,15)
        ac.setFontSize(label_test_msg,10)
        ac.setText(label_test_msg,passwordStore)

    # create zoom button
    button_Zoom = ac.addButton(appWindow,"")
    ac.setBackgroundOpacity(button_Zoom, 0)
    ac.drawBorder(button_Zoom, 0)
    
    # create listener for zoom buttons
    ac.addOnClickedListener(button_Zoom,click_button_zoom)
    
    ### Check password in the store
    ac.addOnChatMessageListener(appWindow,checkMessage)

    resizeAll(zoomLevel)

    return "admintools"

def acUpdate(deltaT):
    global updUsr, maxConnection, lastMessage, passwordStore, nextTrackSelected,trackMessage
    ### updUsr control the lstUsr class updates
    if updUsr == True:
        for num in range(1,maxConnection):
            lstUsr[num].updateMe()
        updUsr = False
    ### nextTrackSelected control the next track command and relative chat messages
    if nextTrackSelected: 
        if passwordStore == "":
            passwordStore = ac.getText(passwordInput)
            ac.setText(passwordInput,"")
        if time.clock() - lastMessage > 1 and trackMessage == 0:
            trackMessage = 1
            ac.sendChatMessage("*******     WARNING     *******")
        if time.clock() - lastMessage > 3 and trackMessage == 1:
            trackMessage = 2
            ac.sendChatMessage("* we are switching to another track *")
        if time.clock() - lastMessage > 5 and trackMessage == 2:
            trackMessage = 3
            ac.sendChatMessage("* this server will become unavailable soon *")
        if time.clock() - lastMessage > 7 and trackMessage == 3:
            trackMessage = 4
            ac.sendChatMessage("**** please, LOGOUT and REJOIN ****")
        if time.clock() - lastMessage > 15:
            ac.sendChatMessage("/next_track " + passwordStore)
            trackMessage = 0
            nextTrackSelected = False
       
def click_button_zoom(val1,val2):
    global zoomLevel
    zoomLevel = zoomLevel + 0.5
    if zoomLevel >= 3:
        zoomLevel = 1
    resizeAll(zoomLevel)
    
def click_button_upd_user(val3,val4):
    global updUsr
    updUsr = True

def click_button_admin(val1,val2):
    global passwordStore
    passwordStore = ac.getText(passwordInput)
    ac.setText(passwordInput,"")
    ac.sendChatMessage("/admin " + passwordStore)
    
def click_button_nxt_session(val1,val2):
    ac.sendChatMessage("/next_session")
    
def click_button_rst_session(val1,val2):
    ac.sendChatMessage("/restart_session")
    
def click_button_lst_users(val1,val2):    
    ac.sendChatMessage("/client_list")
    
def click_button_kck_user(val1,val2):
    kick_string="/kick_id " + str(int(ac.getValue(spinner_usr_id)))
    ac.sendChatMessage(kick_string)

def click_button_nxt_track(val1,val2):
    global nextTrackSelected, lastMessage
    lastMessage = time.clock()
    nextTrackSelected = True

## Parse server IP from logfile
def parseServerIpFromLogFile(fileName):
    filetoparse = open(fileName, 'r', encoding='utf-8', errors='replace')

    r = re.compile(r'(.*)Updating player list (.*)')
    rf = r' true", source:'

    serverip = ""

    for line in reversed(list(filetoparse)):
        if re.match(r,line):
            m = r.search(line)
            startServerIp = m.group(2)
            serverip = startServerIp[0:startServerIp.rfind(rf)]
            break

    filetoparse.close()
    return serverip

def checkMessage(message, author):
    global passwordarchive,passwordStore
    if (author == "SERVER") and (message == "You are now Admin for this server"):
        ac.setText(button_admin,"Ready to kick!")
        ac.setFontColor(button_admin,1,1,1,1)
        passwordarchive[serverName] = passwordStore
        with open('apps/python/admintools/config/password.txt', 'wb') as handle:
            pickle.dump(passwordarchive, handle)
        
        
def resizeAll(zoomLevel):
    global useAcTrackcycle,useUserId,useUserList,xListStart,yListStart,maxConnection

    startX = 15
    startY = 30*zoomLevel
    spaceX = 5*zoomLevel
    spaceY = 5*zoomLevel
    sizeY = 16*zoomLevel
    xWinSize = 275*zoomLevel
    borderSize = 15
    textSize = sizeY - 5*zoomLevel
    totalRowButtons = 2
    posX = startX
    zoomButtonX = int((xWinSize/4)*3)
    zoomButtonSize = 20
    
    ### Positon and size zoom button
    ac.setSize(button_Zoom,zoomButtonSize,zoomButtonSize)
    ac.setPosition(button_Zoom,zoomButtonX,5)
    ac.setBackgroundTexture(button_Zoom,r"apps\python\admintools\icons\zoom20.png")
    
    #### position and size password input
    ac.setPosition(passwordInput,posX,startY)
    sizeX = int((xWinSize-(borderSize*2)-((totalRowButtons-1)*spaceX))/totalRowButtons)                 ### Input button size
    ac.setSize(passwordInput,sizeX,sizeY)
    ac.setFontSize(passwordInput,textSize)
    posX = posX + sizeX + spaceX
    
    #### position and size button admin
    ac.setPosition(button_admin,posX,startY)
    sizeX = int((xWinSize-(borderSize*2)-((totalRowButtons-1)*spaceX))/totalRowButtons)                 ### Admin Button size
    ac.setSize(button_admin,sizeX,sizeY)
    ac.setFontSize(button_admin,textSize)
    startY = startY + sizeY + spaceY                                                                    ### New Line
    posX = startX

    
    #### position and size button next session
    if useAcTrackcycle:
        totalRowButtons = 3
    ac.setPosition(button_nxt_session,posX,startY)
    sizeX = int((xWinSize-(borderSize*2)-((totalRowButtons-1)*spaceX))/totalRowButtons)                 ### Next Session Button = 1/3 if trackcycle = true 1/2
    ac.setSize(button_nxt_session,sizeX,sizeY)
    ac.setFontSize(button_nxt_session,textSize)
    posX = posX + sizeX + spaceX
    
    #### position and size button restart session
    ac.setPosition(button_rst_session,posX,startY)
    sizeX = int((xWinSize-(borderSize*2)-((totalRowButtons-1)*spaceX))/totalRowButtons)                 ### Restart Session Button = 1/3 if trackcycle = true 1/2
    ac.setSize(button_rst_session,sizeX,sizeY)
    ac.setFontSize(button_rst_session,textSize)
    posX = posX + sizeX + spaceX
    
    #### position and size button next track
    if useAcTrackcycle:
        ac.setPosition(button_nxt_track,posX,startY)
        sizeX = int((xWinSize-(borderSize*2)-((totalRowButtons-1)*spaceX))/totalRowButtons)             ### Next Track Button = 1/3 if trackcycle = true 1/2
        ac.setSize(button_nxt_track,sizeX,sizeY)
        ac.setFontSize(button_nxt_track,textSize)
    startY = startY + sizeY + spaceY                                                                    ### New Line
    posX = startX
    
    if useUserId:
        totalRowButtons = 3
        #### position and size button list users
        ac.setPosition(button_lst_users,posX,startY)
        sizeX = int((xWinSize-(borderSize*2)-((totalRowButtons-1)*spaceX))/totalRowButtons)             ### List User Id Button = 1/3
        ac.setSize(button_lst_users,sizeX,sizeY)
        ac.setFontSize(button_lst_users,textSize)
        posX = posX + sizeX + spaceX
        

        #### position and size spinner user id
        ac.setPosition(spinner_usr_id, posX, startY)
        sizeX = int((xWinSize-(borderSize*2)-((totalRowButtons-1)*spaceX))/totalRowButtons)             ### spinner  = 1/3
        ac.setSize(spinner_usr_id, sizeX, sizeY)
        ac.setFontSize(spinner_usr_id,textSize)
        posX = posX + sizeX + spaceX
        
        #### position and size kick users
        ac.setPosition(button_kck_user,posX,startY)
        sizeX = int((xWinSize-(borderSize*2)-((totalRowButtons-1)*spaceX))/totalRowButtons)             ### kick  = 1/3
        ac.setSize(button_kck_user,sizeX,sizeY)        
        ac.setFontSize(button_kck_user,textSize)
        posX = startX
        startY = startY + sizeY + spaceY                                                                ### New Line
        
    if useUserList:
        totalRowButtons = 1
        #### position and size upd users
        ac.setPosition(button_upd_users,posX,startY)
        sizeX = int((xWinSize-(borderSize*2)-((totalRowButtons-1)*spaceX))/totalRowButtons)             ### update user 1 button
        ac.setSize(button_upd_users,sizeX,sizeY)
        ac.setFontSize(button_upd_users,textSize)
        startY = startY + sizeY + spaceY                                                                ### New Line
        # lstUsr[0].resizeMe(0,0)
        sizeX = int(xWinSize/2-borderSize)
        for num in range(1,maxConnection):
            if num%2 == 0:
                posX = int(xWinSize/2)
                lstUsr[num].resizeMe(posX,startY,sizeX,sizeY,zoomLevel)
                startY = startY + sizeY
            else:
                posX = startX
                lstUsr[num].resizeMe(posX,startY,sizeX,sizeY,zoomLevel)

    
    ac.setSize(appWindow, xWinSize, startY+15)
    
    return

def acShutdown():
    global zoomLevel,config
    try:
        config.set('Zoom',"zoomLevel",str(zoomLevel))
        with open("apps/python/admintools/config/config.ini","w") as configfile:
            config.write(configfile)
        configfile.close()
    except:
        ac.log("Admin tools :: Can't write config")

### User Row Class
class usrRow:

    def __init__(self,app,usrId):
        
        self.usrId = usrId
        self.usrName = ""
        self.usrWrap = ""
        self.usrWarn = 0
        
        # Label
        #self.nameLabel = ac.addLabel(app, "nameLabel")
        
        # Label Text
        #ac.setText(self.nameLabel,self.usrName)
        
        # Warning Button
        self.warnButton = ac.addButton(app,"warnButton")
        self.kickButton = ac.addButton(app,"kickButton")
        
        # Button Text
        ac.setText(self.warnButton,self.usrName)
        ac.setText(self.kickButton,"K")
        
        # Workaround for buttons
        self.kickEvent = self.click_kickButton
        self.warnEvent = self.click_warnButton
        
        # Set Initial Visibility to none
        #ac.setVisible(self.nameLabel,0)
        ac.setVisible(self.warnButton,0)
        ac.setVisible(self.kickButton,0)
        
        # Add Listener
        ac.addOnClickedListener(self.kickButton,self.kickEvent)
        ac.addOnClickedListener(self.warnButton,self.warnEvent)
    
    def updateMe(self):
        usrName = ac.getDriverName(self.usrId)
        try:
            if (type(usrName) == type ("")) and (usrName != self.usrName):
                # New user: reset parameters
                self.usrWarn = 0
                self.usrName = usrName
                usrNameLenght = len(self.usrName)
                if usrNameLenght > 17:
                    self.usrWrap = self.usrName[0:10] + "[..]" + self.usrName[usrNameLenght-3:usrNameLenght]
                else:
                    self.usrWrap = self.usrName
                #ac.setVisible(self.nameLabel,1)
                ac.setVisible(self.warnButton,1)
                ac.setVisible(self.kickButton,1)
                #ac.setText(self.nameLabel,self.usrWrap)
                ac.setText(self.warnButton,self.usrWrap)
                #ac.setFontColor(self.nameLabel,1,1,1,1)
                ac.setFontColor(self.warnButton,1,1,1,1)
            if type(usrName) != type (""):
                # Empty slot: reset attr and hide unused labels
                self.usrName = ""
                self.usrWrap = ""
                self.usrWarn = 0
                #ac.setVisible(self.nameLabel,0)
                ac.setVisible(self.warnButton,0)
                ac.setVisible(self.kickButton,0)
        except:
            ac.log("Admin tools :: Can't get drivername")
        
    def click_kickButton(self,val1,val2):
        if devMode:
            ac.setText(label_test_msg,"/Kick " + str(self.usrName))
        else:
            ac.sendChatMessage("/kick " + self.usrName)
        #ac.setFontColor(self.nameLabel,0.7,0,0.7,1)
        ac.setFontColor(self.warnButton,0.7,0,0.7,1)
        
    def click_warnButton(self,val5,val6):
        global useAutoKick
        self.usrWarn = self.usrWarn + 1
        red = 1
        green = 1 - self.usrWarn / maxWarnLevel
        blu = 0
        
        if self.usrWarn > maxWarnLevel and useAutoKick:
            #ac.setFontColor(self.nameLabel,0.7,0,0.7,1)
            ac.setFontColor(self.warnButton,0.7,0,0.7,1)
            finalMessage = "/kick " + self.usrName
        else:
            #ac.setFontColor(self.nameLabel,red,green,blu,1)
            ac.setFontColor(self.warnButton,red,green,blu,1)
            finalMessage = warningMessage
            finalMessage = finalMessage.replace ("$$w" , str(self.usrWarn))
            finalMessage = finalMessage.replace ("$$u" , self.usrName )

        if devMode:
            ac.setText(label_test_msg,finalMessage)
        else:
            ac.sendChatMessage(finalMessage)

    def resizeMe(self,x,y,sx,sy,zoomLevel):
        ## Label Position
        ## ac.setPosition(self.nameLabel,x,y)
        ## Label Size
        ##ac.setSize(self.nameLabel,sx-sy*2,sy)
        ## Label FontSize
        ##ac.setFontSize(self.nameLabel,sy-4*zoomLevel)
        ## Button Position
        ## ac.setPosition(self.warnButton,x+sx-sy*2,y)
        ac.setPosition(self.warnButton,x,y)
        ac.setPosition(self.kickButton,x+sx-sy*2,y)
        ## Button Size
        ac.setSize(self.warnButton,sx-sy*2,sy)
        ac.setSize(self.kickButton,sy*2,sy)
        ## Button FontSize
        ac.setFontSize(self.warnButton,sy-4*zoomLevel)
        ac.setFontSize(self.kickButton,sy-4*zoomLevel)
